CTATracker_HeroicWatch = true;
CTATracker_HeroicTankWatch = false;
CTATracker_HeroicHealerWatch = false;
CTATracker_HeroicDPSWatch = false;
CTATracker_CurrentlyHeroicCTA = false;
CTATracker_DungeonID = 789;
SLASH_CTA1 = '/cta';

function CTATracker_handler(msg, editbox)
	if CTATracker_MainFrame:IsVisible() and msg=="" then
		CTATracker_MainFrame:Hide();
	elseif msg=="" then
		CTATracker_MainFrame:Show();
		CTATracker_LFGUpdate();
	end
	if msg == "hwatch" then
		CTATracker_HeroicWatchConfig();
	end
	if msg == "hwatchtank" then
		CTATracker_HeroicWatchTank();
	end
	if msg == "hwatchhealer" then
		CTATracker_HeroicWatchHealer();
	end
	if msg == "hwatchdps" then
		CTATracker_HeroicWatchDPS();
	end
	if msg == "status" then
		CTATracker_Status();
	end
	if msg == "help" then
		CTATracker_Help();
	end
end
SlashCmdList["CTA"] = CTATracker_handler;

function CTATracker_UpdateInterval(self, elapsed)
	self.CTATracker_TimeSinceLastUpdate = self.CTATracker_TimeSinceLastUpdate + elapsed;
	if (self.CTATracker_TimeSinceLastUpdate > 20.0) then
		RequestLFDPlayerLockInfo();
		self.CTATracker_TimeSinceLastUpdate = 0.0;
	end
end

function CTATracker_LFGUpdate()
	CTATracker_CurrentlyHeroicCTA = false; --tracks which dungeons are CTA status true
	CTATracker_RoleFontStringTable = {CTATracker_HTankFontString,CTATracker_HHealerFontString,CTATracker_HDPSFontString};
	local addedWidth = 2;
	local tank = false;
	local healer = false;
	local dps = false;
	CTATracker_MainFrame:SetHeight(15); --- sets display height
	for i=1, 3 do
		CTATracker_RoleFontStringTable[i]:Hide();
	end
	--loops through CTA possiblities and displays current CTA if any
	for i=1, 3 do
	if(select((i+1),GetLFGRoleShortageRewards(CTATracker_DungeonID,LFG_ROLE_SHORTAGE_RARE)) == true) then
			CTATracker_RoleFontStringTable[i]:SetPoint("TOPLEFT",addedWidth,-2.0);
			CTATracker_RoleFontStringTable[i]:Show();
			addedWidth = addedWidth + CTATracker_RoleFontStringTable[i]:GetWidth();
			CTATracker_CurrentlyHeroicCTA = true;
			if i == 1 then
				tank = true;
			end
			if i == 2 then
				healer = true;
			end
			if i == 3 then
				dps = true;
			end
		else
			CTATracker_RoleFontStringTable[i]:Hide();
			if i == 1 then
				tank = false;
			end
			if i == 2 then
				healer = false;
			end
			if i == 3 then
				dps = false;
			end
		end
	end

	if (CTATracker_CurrentlyHeroicCTA == true) then
		if CTATracker_HeroicWatch == true then
			CTATracker_MainFrame:SetHeight(15);
			CTATracker_MainFrame:Show();
		elseif CTATracker_HeroicTankWatch == true and tank == true then
			CTATracker_MainFrame:SetHeight(15);
			CTATracker_MainFrame:Show();
		elseif CTATracker_HeroicHealerWatch == true and healer == true then
			CTATracker_MainFrame:SetHeight(15);
			CTATracker_MainFrame:Show();
		elseif CTATracker_HeroicDPSWatch == true and dps == true then
			CTATracker_MainFrame:SetHeight(15);
			CTATracker_MainFrame:Show();
		end
	end
	CTATracker_MainFrame:SetWidth(addedWidth+1);
end

function CTATracker_HeroicWatchConfig()
	if CTATracker_HeroicWatch == true then
		print("CTA: Heroic watching - off.");
		CTATracker_HeroicWatch = false;
		CTATracker_LFGUpdate();
	else
		print("CTA: Heroic watching - on.");
		CTATracker_HeroicWatch = true;
		CTATracker_LFGUpdate();
	end
end

function CTATracker_HeroicWatchTank()
	if(CTATracker_HeroicTankWatch == true) then
		print("CTA: Heroic Tank watching - off");
		CTATracker_HeroicTankWatch = false;
	else
		print("CTA: Heroic Tank watching - on");
		print("CTA: Heroic watching - off.");
		CTATracker_HeroicTankWatch = true;
		CTATracker_HeroicWatch = false;
	end
end
function CTATracker_HeroicWatchHealer()
	if(CTATracker_HeroicHealerWatch == true) then
		print("CTA: Heroic Healer watching - off");
		CTATracker_HeroicHealerWatch = false;
	else
		print("CTA: Heroic Healer watching - on");
		print("CTA: Heroic watching - off.");
		CTATracker_HeroicHealerWatch = true;
		CTATracker_HeroicWatch = false;
	end
end
function CTATracker_HeroicWatchDPS()
	if(CTATracker_HeroicDPSWatch == true) then
		print("CTA: Heroic DPS watching - off");
		CTATracker_HeroicDPSWatch = false;
	else
		print("CTA: Heroic DPS watching - on");
		print("CTA: Heroic watching - off.");
		CTATracker_HeroicDPSWatch = true;
		CTATracker_HeroicWatch = false;
	end
end
function CTATracker_Status()
	print("~~~~~~~~~~~~~~~~~~~~");
	print("Call to arms status");
	print("~~~~~~~~~~~~~~~~~~~~");
	if(CTATracker_HeroicWatch == true) then
		print("CTA: Heroic watching - on");
	else
		print("CTA: Heroic watching - off");
	end
	if(CTATracker_HeroicTankWatch == true) then
		print("CTA: Heroic Tank watching - on");
	else
		print("CTA: Heroic Tank watching - off");
	end
	if(CTATracker_HeroicHealerWatch == true) then
		print("CTA: Heroic Healer watching - on");
	else
		print("CTA: Heroic Healer watching - off");
	end
	if(CTATracker_HeroicDPSWatch == true) then
		print("CTA: Heroic DPS watching - on");
	else
		print("CTA: Heroic DPS watching - off");
	end
	if(CTATracker_CurrentlyHeroicCTA == true) then
		print("There is currently a CTA");
	else
		print("There is currently no CTA");
	end
end

function CTATracker_Help()
	print("~~~~~~~~~~~~~~~~~~~~");
	print("Call to arms help");
	print("~~~~~~~~~~~~~~~~~~~~");
	print("/cta - toggles show or hide of frame, if you show a frame when there is no cta frame is small moveable sliver");
	print("/cta hwatch - toggles whether to watch for a heroic CTA. If you are watching for a CTA the frame will auto show when the addon finds one. This is the same as having hwatchtank,hwatchhealer,and hwatchdps all on.");
	print("/cta hwatchtank - toggles to watch specifically for tank CTA, will turn off general CTA watching.");
	print("/cta hwatchhealer - toggles to watch specifically for healer CTA, will turn off general CTA watching.");
	print("/cta hwatchdps - toggles to watch specifically for DPS CTA, will turn off general CTA watching.");
	print("/cta status - prints if currently watching for heroic CTA and if there is a known CTA ongoing");
	print("/cta help - prints this menu");
end

function CTATracker_HideMainFrame()
	CTATracker_MainFrame:Hide();
end
